<template>
  <div id="result-table" class="table-responsive">
    <table class="table table-striped table-hover">
      <thead>
        <tr>
          <th scope="col">{{ $t('general.journal') }}</th>
          <th scope="col">{{ $t('general.score') }}</th>
          <th v-if="is_extension" scope="col">{{ $t('extension.badge_table_header') }}</th>
          <th v-if="label_mirror_journals" scope="col">Mirror Journal</th>
          <th scope="col">{{ $t('general.alternative_title') }}</th>
          <th scope="col">{{ $t('general.publisher') }}</th>
          <th scope="col" class="table-cell-min">{{ $t('general.apcs') }}</th>
          <th scope="col" class="table-cell-min">{{ $t('general.languages') }}</th>
          <th scope="col">{{ $t('general.retain_copyright') }}</th>
          <th scope="col">{{ $t('general.receives_doi') }}</th>
          <th scope="col" class="table-cell-min">{{ $t('general.peer_review') }}</th>
          <th scope="col">{{ $t('general.publication_time') }}</th>
          <th scope="col">{{ $t('general.plans') }}</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="(journal, index) in results" :key="index">
          <th scope="row">
            <router-link :to="{ name: 'Journal', params: { id: journal.id }}">
              {{ journal.title }}
            </router-link>
          </th>
          <th scope="row" class="score-cell">
            <score-popover class="score-popovers" :journal="journal">
              <div class="score-text">{{ score_precision(journal.score.value) }}</div>
            </score-popover>
          </th>
          <td v-if="is_extension"><journal-eligibility-badge :journal="journal"></journal-eligibility-badge></td>
          <th v-if="label_mirror_journals" scope="col">{{ value_or_none(journal.mirror_journal) }}</th>
          <td>{{ value_or_none(journal.alternative_title) }}</td>
          <td>{{ value_or_none(journal.publisher_name) }}</td>
          <td v-if="journal.has_apc">{{ journal.apc_max.price }} {{ journal.apc_max.currency }}<span v-if="journal.apc_max.euro"><br/> (approx. {{ journal.apc_max.euro }}€)</span></td>
          <td v-else>-</td>
          <td>{{ value_or_none(journal.languages) }}</td>
          <td>{{ value_or_none(journal.copyright_author_retains) }}</td>
          <td>{{ value_or_none(journal.doi_pid_scheme) }}</td>
          <td>{{ value_or_none(journal.editorial_review_process) }}</td>
          <td>{{ value_or_none(journal.publication_time_weeks) }}</td>
          <td>{{ value_or_none(journal.plan_s_compliance) }}</td>
        </tr>
      </tbody>
    </table>
  </div>
</template>
<script>
import helper from '../helper'
import ScorePopover from './ScorePopover.vue'
import JournalEligibilityBadge from './JournalEligibilityBadge.vue'
import { mapState } from 'vuex'

export default {
  name: 'SearchResultsTable',
  mixins: [helper],
  components: { JournalEligibilityBadge, ScorePopover },
  props: {
    results: {
      type: Array,
      required: true
    }
  },
  methods: {
    value_or_none (v) {
      if (v === null) {
        return '-'
      } else if (typeof v === 'boolean') {
        return this.bool_to_unicode(v)
      } else if (Array.isArray(v)) {
        return this.array_to_string(v)
      }
      return v
    }
  },
  computed: {
    ...mapState({
      is_extension: state => state.extension.is_set,
      label_mirror_journals: state => state.extension.is_set && state.extension.mirror_handling === 'LABEL'
    })
  }
}
</script>
<style scoped>
.table-cell-min {
  min-width: 150px;
}
#result-table {
  /* detour with extra calc so that older browser simply ignore it */
  width: calc(0px + min(90vw, 1500px));
  left: calc((100% - min(90vw, 1500px))/2);
  position: relative;
}

/* Extend score to cover the whole cell -> whole cell clickable */
.score-popovers {
  width: 100%;
  height: 100%;
  display: table;
}
.score-text {
  padding: 0.5rem;
}
.score-popovers:hover {
  background-color:rgba(0, 0, 0, 0.05);
}
.score-cell {
  height: 1px;
  padding: 0 0;
}
</style>
